<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>WatchManager.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">WatchManager.java</span></div><h1>WatchManager.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.io.PrintWriter;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;
import java.util.Map.Entry;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.WatchedEvent;
import org.apache.zookeeper.Watcher;
import org.apache.zookeeper.Watcher.Event.EventType;
import org.apache.zookeeper.Watcher.Event.KeeperState;

/**
 * This class manages watches. It allows watches to be associated with a string
 * and removes watchers and their watches in addition to managing triggers.
 */
<span class="fc" id="L38">public class WatchManager {</span>
<span class="fc" id="L39">    private static final Logger LOG = LoggerFactory.getLogger(WatchManager.class);</span>

<span class="fc" id="L41">    private final HashMap&lt;String, HashSet&lt;Watcher&gt;&gt; watchTable =</span>
        new HashMap&lt;String, HashSet&lt;Watcher&gt;&gt;();

<span class="fc" id="L44">    private final HashMap&lt;Watcher, HashSet&lt;String&gt;&gt; watch2Paths =</span>
        new HashMap&lt;Watcher, HashSet&lt;String&gt;&gt;();

    public synchronized int size(){
<span class="fc" id="L48">        int result = 0;</span>
<span class="fc bfc" id="L49" title="All 2 branches covered.">        for(Set&lt;Watcher&gt; watches : watchTable.values()) {</span>
<span class="fc" id="L50">            result += watches.size();</span>
<span class="fc" id="L51">        }</span>
<span class="fc" id="L52">        return result;</span>
    }

    public synchronized void addWatch(String path, Watcher watcher) {
<span class="fc" id="L56">        HashSet&lt;Watcher&gt; list = watchTable.get(path);</span>
<span class="fc bfc" id="L57" title="All 2 branches covered.">        if (list == null) {</span>
            // don't waste memory if there are few watches on a node
            // rehash when the 4th entry is added, doubling size thereafter
            // seems like a good compromise
<span class="fc" id="L61">            list = new HashSet&lt;Watcher&gt;(4);</span>
<span class="fc" id="L62">            watchTable.put(path, list);</span>
        }
<span class="fc" id="L64">        list.add(watcher);</span>

<span class="fc" id="L66">        HashSet&lt;String&gt; paths = watch2Paths.get(watcher);</span>
<span class="fc bfc" id="L67" title="All 2 branches covered.">        if (paths == null) {</span>
            // cnxns typically have many watches, so use default cap here
<span class="fc" id="L69">            paths = new HashSet&lt;String&gt;();</span>
<span class="fc" id="L70">            watch2Paths.put(watcher, paths);</span>
        }
<span class="fc" id="L72">        paths.add(path);</span>
<span class="fc" id="L73">    }</span>

    public synchronized void removeWatcher(Watcher watcher) {
<span class="fc" id="L76">        HashSet&lt;String&gt; paths = watch2Paths.remove(watcher);</span>
<span class="fc bfc" id="L77" title="All 2 branches covered.">        if (paths == null) {</span>
<span class="fc" id="L78">            return;</span>
        }
<span class="fc bfc" id="L80" title="All 2 branches covered.">        for (String p : paths) {</span>
<span class="fc" id="L81">            HashSet&lt;Watcher&gt; list = watchTable.get(p);</span>
<span class="pc bpc" id="L82" title="1 of 2 branches missed.">            if (list != null) {</span>
<span class="fc" id="L83">                list.remove(watcher);</span>
<span class="pc bpc" id="L84" title="1 of 2 branches missed.">                if (list.size() == 0) {</span>
<span class="fc" id="L85">                    watchTable.remove(p);</span>
                }
            }
<span class="fc" id="L88">        }</span>
<span class="fc" id="L89">    }</span>

    public Set&lt;Watcher&gt; triggerWatch(String path, EventType type) {
<span class="fc" id="L92">        return triggerWatch(path, type, null);</span>
    }

    public Set&lt;Watcher&gt; triggerWatch(String path, EventType type, Set&lt;Watcher&gt; supress) {
<span class="fc" id="L96">        WatchedEvent e = new WatchedEvent(type,</span>
                KeeperState.SyncConnected, path);
        HashSet&lt;Watcher&gt; watchers;
<span class="fc" id="L99">        synchronized (this) {</span>
<span class="fc" id="L100">            watchers = watchTable.remove(path);</span>
<span class="pc bpc" id="L101" title="1 of 4 branches missed.">            if (watchers == null || watchers.isEmpty()) {</span>
<span class="pc bpc" id="L102" title="1 of 2 branches missed.">                if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L103">                    ZooTrace.logTraceMessage(LOG,</span>
                            ZooTrace.EVENT_DELIVERY_TRACE_MASK,
                            &quot;No watchers for &quot; + path);
                }
<span class="fc" id="L107">                return null;</span>
            }
<span class="fc bfc" id="L109" title="All 2 branches covered.">            for (Watcher w : watchers) {</span>
<span class="fc" id="L110">                HashSet&lt;String&gt; paths = watch2Paths.get(w);</span>
<span class="pc bpc" id="L111" title="1 of 2 branches missed.">                if (paths != null) {</span>
<span class="fc" id="L112">                    paths.remove(path);</span>
                }
<span class="fc" id="L114">            }</span>
<span class="pc" id="L115">        }</span>
<span class="fc bfc" id="L116" title="All 2 branches covered.">        for (Watcher w : watchers) {</span>
<span class="pc bpc" id="L117" title="3 of 4 branches missed.">            if (supress != null &amp;&amp; supress.contains(w)) {</span>
<span class="nc" id="L118">                continue;</span>
            }
<span class="fc" id="L120">            w.process(e);</span>
<span class="fc" id="L121">        }</span>
<span class="fc" id="L122">        return watchers;</span>
    }

    /**
     * Brief description of this object.
     */
    @Override
    public synchronized String toString() {
<span class="fc" id="L130">        StringBuilder sb = new StringBuilder();</span>

<span class="fc" id="L132">        sb.append(watch2Paths.size()).append(&quot; connections watching &quot;)</span>
<span class="fc" id="L133">            .append(watchTable.size()).append(&quot; paths\n&quot;);</span>

<span class="fc" id="L135">        int total = 0;</span>
<span class="fc bfc" id="L136" title="All 2 branches covered.">        for (HashSet&lt;String&gt; paths : watch2Paths.values()) {</span>
<span class="fc" id="L137">            total += paths.size();</span>
<span class="fc" id="L138">        }</span>
<span class="fc" id="L139">        sb.append(&quot;Total watches:&quot;).append(total);</span>

<span class="fc" id="L141">        return sb.toString();</span>
    }

    /**
     * String representation of watches. Warning, may be large!
     * @param byPath iff true output watches by paths, otw output
     * watches by connection
     * @return string representation of watches
     */
    public synchronized void dumpWatches(PrintWriter pwriter, boolean byPath) {
<span class="fc bfc" id="L151" title="All 2 branches covered.">        if (byPath) {</span>
<span class="fc bfc" id="L152" title="All 2 branches covered.">            for (Entry&lt;String, HashSet&lt;Watcher&gt;&gt; e : watchTable.entrySet()) {</span>
<span class="fc" id="L153">                pwriter.println(e.getKey());</span>
<span class="fc bfc" id="L154" title="All 2 branches covered.">                for (Watcher w : e.getValue()) {</span>
<span class="fc" id="L155">                    pwriter.print(&quot;\t0x&quot;);</span>
<span class="fc" id="L156">                    pwriter.print(Long.toHexString(((ServerCnxn)w).getSessionId()));</span>
<span class="fc" id="L157">                    pwriter.print(&quot;\n&quot;);</span>
<span class="fc" id="L158">                }</span>
<span class="fc" id="L159">            }</span>
        } else {
<span class="fc bfc" id="L161" title="All 2 branches covered.">            for (Entry&lt;Watcher, HashSet&lt;String&gt;&gt; e : watch2Paths.entrySet()) {</span>
<span class="fc" id="L162">                pwriter.print(&quot;0x&quot;);</span>
<span class="fc" id="L163">                pwriter.println(Long.toHexString(((ServerCnxn)e.getKey()).getSessionId()));</span>
<span class="fc bfc" id="L164" title="All 2 branches covered.">                for (String path : e.getValue()) {</span>
<span class="fc" id="L165">                    pwriter.print(&quot;\t&quot;);</span>
<span class="fc" id="L166">                    pwriter.println(path);</span>
<span class="fc" id="L167">                }</span>
<span class="fc" id="L168">            }</span>
        }
<span class="fc" id="L170">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>